#ifndef __TDBDATA_H__
#define __TDBDATA_H__

#include "tdb.h"

template <typename T>
class TDBData
{
protected :
    TDB *db;

public :
    TDBData(const char *dbname){
        db = new TDB(dbname);
    };

    ~TDBData()
    {
        delete db;
    };

    int Read(T &outdata)
    {
        return db->Read(outdata.key, (char *)&outdata);
    };

    int Read(const char *key, T &outdata)
    {
        return db->Read(key, (char *)&outdata);
    };

    int Write(T &indata)
    {
        return db->Update(indata.key, (char *)&indata, sizeof(T));
    };

    TDBData &operator << (const T &dw)
    {
        db->Update(dw.key, (char *)&dw, sizeof(T));
        return (*this);
    };
};

#endif

